c ***********************************************************************
c  
      subroutine func(u,irow,icol,iplane,t,f)
c
c ----------------------------------------------------------------------      
      save
c
      include './params.inc'

      integer i,icol,ii,ijac,iplane,irow

      real*8 CaER,CaER0,Jchan,c,ch1,f(nvar),g1,h,hc(nx,ny,nz),
     . l1,l2,l3,l_1,l_2,l_3,m1,m2,p1, p2,p3,par1,t,
     . u(nvar),u4,vratio

      logical iflag

      common /param/ par1(50)

      data iflag/.true./
c
c Set H at the space-dependent parameters (only H at present). The 
c value returned is used in f(5). hc(i,j,k) contains the fixed hormome
c concentration at (i,j,k).
c
      if(iflag)then

         call spacedep(hc)
         write(14,*) ' H used in func is:'
         write(14,*) ' H(1,1)= ', hc(1,1,1)
         write(14,*) ' H((nx+1)/2,(ny+1)/2,(nz+1)/2)= ', 
     .        hc((nx+1)/2,(ny+1)/2,(nz+1)/2)
         write(14,*)

      l1=par1(1)
      l2=par1(2)
      l3=par1(3)
c
      l_1=par1(4)
      l_2=par1(5)
      l_3=par1(6)
c
      p1=par1(7)
      p2=par1(8)
      p3=par1(9)
c
      ch1  = par1(10)
      CaER0= par1(11)

      vratio=par1(12)
      g1=par1(13)
      h = par1(14)
      m1 = par1(15)
      m2 = par1(16) 

         iflag = .false.
      endif

c--------------------------------------------------------------------
c
c Set up the conservation condition

      c=0.d0
      do i=1,3
         c=c+u(i)
      enddo

      u4=1-c
 
      CaER=CaER0-u(4)/vratio

      Jchan =ch1*u(3)*(CaER-u(4))

      f(1)=-l1*u(5)*u(1)+l_1*u(2)

      f(2) =-(l2*u(4)+ l_1)*u(2)+l_2*u(3) + l1*u(5)*u(1)

      f(3) =-(l3*u(4)+l_2)*u(3)+l2*u(4)*u(2)+l_3*u4
c
      f(4) =vratio*g1*(CaER-u(4))-p1*((u(4)/p3)**p2)
     .          /((u(4)/p3)**p2 + 1.) + vratio*Jchan

      f(5) = m1*hc(icol,irow,iplane)-m2*u(5)
c
      return
      end
c
c------------------------------------------------------------------
c
      subroutine spacedep(h)
c ----------------------------------------------------------------
c          sets space dependent parameters (at present only H)
c
c Calling this initially from start one can set the initial value
c of IP3. Calling it in func one can set the distribution of H for
c all time.
c ----------------------------------------------------------------

      include 'params.inc'

      integer*4 i,icent,j,k,l,m,n
      real*8 x(nx),y(ny),z(nz),h(nx,ny,nz)
c     
c     Computaion of the mesh points.
c     
         do i = 1,nx
            x(i)= hx*dfloat(i-1) 
         end do

         do j = 1,ny
            y(j)= hy*dfloat(j-1) 
         end do

         do k = 1,nz
            z(k)= hz*dfloat(k-1) 
         enddo
c     
c ------------------------------------------------
c       initialize the hormone distribution
c ------------------------------------------------ 
c
      do n = 1,nz
	do m = 1,ny
	   do l=1,nx
              if((x(l)-0.5)**2  + (z(n)-0.5)**2 
     .             .gt. .0051)then
                 h(l,m,n) = .5d0
              else
                 h(l,m,n) = .5d0
              endif
           enddo
        enddo
      enddo         

c       write(6,*) h((nx+1)/2,(ny+1)/2,(nz+1)/2) 
c      write(19,*) (((sngl(h(l,m,n)),l=1,nx),m=1,ny),n=1,nz)

      return
      end
c------------------------------------------------------------

