      integer*4 ibc         ! uniform BC: 0. Neumman, 2. Dirichlet

      integer*4 jn          ! output ever jnth step
c     integer*4 nsteps      ! number of time steps
      integer*4 nparam      ! number of parameters for kinetics

      integer nx,ny,nz      ! number of mesh points

      integer*4 nvar        ! number of variables
      integer*4 ndiff       ! number of diffusing variables
      integer*4 nstat       ! number of non-diffusing variables

      integer*4 neqn        ! total number of unknowns
      integer*4 meqnx       ! total # of vars/'row'
      integer*4 meqny       ! total # of vars/'col'
      integer*4 meqnz       ! total # of vars/'col'
      integer*4 meqn        ! max(meqnx,meqny,meqnz)

      real*8    hx          ! length of mesh in x direction
      real*8    hy          ! length of mesh in y direction
      real*8    hz          ! length of mesh in z direction
      real*8    ht0         ! initial length of time step
      real*8    dmcheps     ! machine epsilon
      real*8    sizex       ! domain size (x direction)
      real*8    sizey       ! domain size (y direction)
      real*8    sizez       ! domain size (z direction)
      real*8    tstart      ! time of first output
c     real*8    tfinal      ! final time 

      real*8    htmax       ! max length of time step
      real*8    par(15)     ! parameter vector for diffusion coefficients
c
c We allow different diffusion coefficients in the three directions, 
c and we store them by species in the three directions. Thus 
c par(1)-par(ndiff) are the diffusion coeffs of u_l (l=1,...ndiff) in 
c the x,y,z directions, and the length of par()>=3*ndiff. 
c We don't take advantage of
c the fact that the gates could be updated separately. 
c
      parameter (ibc=2)

      parameter (nx=101,ny=101,nz=101)          
      parameter (ndiff=1)
      parameter (nstat=1)
      parameter (nparam=9)
      parameter (nvar=ndiff+nstat)
      parameter (neqn=nvar*nx*ny*nz)
      parameter (meqnx=nvar*nx)
      parameter (meqny=nvar*ny)
      parameter (meqnz=nvar*nz)
      parameter (meqn=meqnx)   !This has to be the max of meqnx,meqny,meqnz

      parameter (htmax = 0.1d0)
c     parameter (nsteps = 10)      
      parameter(jn = 25)   
      parameter(sizex=1.d0,sizey=1.d0,sizez=1.d0)   
      parameter(tstart = 0.d0)   
c
c For Neumann BC, h = size/(n-1) but for Dirichlet BC, h = size/(n+1)
c
      parameter (hx = sizex/(nx-1+ibc))  
      parameter (hy = sizey/(ny-1+ibc))
      parameter (hz = sizez/(nz-1+ibc))

      parameter (ht0 = 1.d-3)
      parameter (dmcheps = 1.0d-15)
c     parameter(tfinal = dfloat(nsteps)*ht0)

      common/data_par/par






