c
      subroutine start(t,v,restart,idr,filename3)

c -------------------------------------------------------------------
c The initial condition for the parabolic routine is loaded
c here.  It may be loaded from a "drop" file (restart = true)
c or built from an algorithm (restart = false).
c
c    author silvia Veronese Jan 27,95
c     modified by H. G. Othmer Nov, 1995, Dec, 1996, Jan, 1997
c -------------------------------------------------------------------

      include 'params.inc'

      integer i,j,k,l,ii
      integer idr
      integer ind
c     integer intran1
      integer m                !starting point depending on BC

      double precision v(4*neqn),t, par1(50), p0(neqn)
      double precision x(nx),y(ny),z(nz), u0(nvar), pi

      character*15 filename3
      character*10 bc 

      logical restart
      common/bound_cond/ bc
      common/param/par1
      common/testp/p0
            
      pi=3.141592654d0

      if(restart) then
         open(unit=idr,file=filename3,status='old')

         read(idr,'(1pd16.8)')t
         read(idr,100)par
         read(idr,100)v

         close(idr)
         
      else
c     
c     The matrix containing the mesh points is set.
c     
         if( bc .eq. 'neumann') then
            m = 0
         elseif(bc .eq. 'dirichlet') then
            m = 1
         endif
c
      do i = 1,nx
         x(i)= dfloat(i+m-1)*hx
      end do
c
      do i = 1,ny
         y(i)= dfloat(i+m-1)*hy
      end do
c
      do i = 1,nz
         z(i)= dfloat(i+m-1)*hz
      end do
c
c     Performs initialization:
c     
c     
c     Set the initial conditions at the steady state for H = .35,
c     which is the Hopf bifurcation point, and subtract .01 from H
c     
      u0(1) = par1(8)
      u0(2) = par1(9)
c
      do k = 1, nz
         do j =1, ny
            do l = 1, nvar
               do i = 1, nx
                  ind = i+(l-1)*nx+(j-1)*meqnx+(k-1)*meqn*ny
c
                  if(bc .eq. 'neumann') then
                     p0(ind) = dcos(par1(5)*pi*x(i))
     .                       *dcos(par1(6)*pi*y(j))
     .                       *dcos(par1(7)*pi*z(k))
c
                  elseif(bc .eq. 'dirichlet') then
                     p0(ind) = dsin(par1(5)*pi*x(i))
     .                       *dsin(par1(6)*pi*y(j))
     .                       *dsin(par1(7)*pi*z(k))
                  endif
c
               enddo
            enddo
         enddo
      enddo
c
c         u0(1)=  0.9803399673805524
c         u0(2)=  1.4705099510708283E-02
c         u0(3)=  3.9530109793736558E-03
c         u0(4)=  2.9570096238686204E-02
c         u0(5) = 0.5
c
      do ii =1,4
         do k = 1,nz
            do j = 1,ny
               do l=1, nvar
                  do i = 1,nx
c
c Determine  the index for the "current" solution (ii = 1) 
c                  
                     ind = i+(l-1)*nx+(j-1)*meqnx+(k-1)*meqn*ny

c  pack all four time slots with the same values 
                     
                     v(ind+(ii-1)*neqn)=  u0(l)*p0(ind)
c                     v(ind+(ii-1)*neqn)=  u0(l)

                  enddo 
               end do
            end do
         end do
      end do
     
      endif
c
c     Write the calcium distribution along y = 0.5 
c
CC       write(14,*) 'In start2, the calcium distribution along y =.5 is'
CC       write(14,*) (v(i+(ny+1)*meqnx/2 + 3*nx), i=1,nx)
CC       write(14,*) 'In start2, the calcium distribution along x =.5 is'
CC       write(14,*) (v((nx+1)/2 +(i-1)*meqnx + 3*nx), i=1,ny)

CC       write(6,100) ((((v(i+ (jj-1)*nx+(j-1)*meqnx+(k-1)*meqnx*ny),  
CC     . i=1,nx),jj=1,nvar),j = 1,ny), k=1,nz)

 100  format(1x,5d14.6)
      
      close(8)

      return
      end
