c ***********************************************************************
c  
      subroutine func(u,irow,icol,iplane,t,f)
c
c ---------------------------------------------------------------------- 
c
c     f2(u,v) = -a*u - b*v           u: u(2)
c     f1(u,v) =  c*u - d*v           v: u(1)
c
c     dv/dt = f1
c     du/dt = mu*(u_xx+u_yy+u_zz) + f2
c
c--------------------------------------------------- 
      save
c
      include './params.inc'

c     integer i,icol,iplane,irow
      integer icol,iplane,irow
      double precision a,b,c,d
      double precision t, f(nvar), u(nvar)
      double precision par1(50)

      common/param/par1

      a = par1(1)
      b = par1(2)
      c = par1(3)
      d = par1(4)

      f(2) = -a*u(2) - b*u(1)
      f(1) = c*u(2) - d*u(1)
c      write(6,*) 'a,b,c,d', a,b,c,d

      return
      end
c-------------------------------------------------------------
c
      subroutine comparison(t,v)
c
c-------------------------------------------------------------
c
      include './params.inc'

c     integer i,j,k,l,icol,iplane,irow, index
      integer i,j,k,l,index
      double precision a,b,c,d
      double precision lambd1,lambd2, mu1,mu2, pi, det
      double precision ev1(nvar), ev2(nvar), coef1, coef2
      double precision t, p0(neqn), p(neqn), u0(nvar),v(4*neqn)
      double precision par1(50)
      double precision errm, err2

      common/param/par1
      common/testp/p0

      pi=3.141592654d0

      a = par1(1)
      b = par1(2)
      c = par1(3)
      d = par1(4)
      u0(1) = par1(8)
      u0(2) = par1(9)

      lambd1 = par(3)*pi**2*(par1(5)**2+par1(6)**2+par1(7)**2)
      lambd2 = par(6)*pi**2*(par1(5)**2+par1(6)**2+par1(7)**2)
      det = dsqrt((lambd1+lambd2+a+d)**2
     .    - 4.d0*((lambd2+a)*(lambd1+d)+b*c))
      mu1 = 0.5d0*(-(lambd1+lambd2+a+d)+det)
      mu2 = 0.5d0*(-(lambd1+lambd2+a+d)-det)
      
      if(dabs(mu1+d+lambd1) .gt. 0.d0) then
         ev1(1) = c/(mu1+d+lambd1)
         ev1(2) = 1.d0
         ev2(1) = 1.d0
         ev2(2) = -b/(mu2+a+lambd2)
      else
         ev1(1) = 1.d0
         ev1(2) = -b/(mu1+a+lambd2)
         ev2(1) = c/(mu2+d+lambd1)
         ev2(2) = 1.d0
      endif

      coef2 = (u0(1)*ev1(2) - u0(2)*ev1(1))
     .      /(ev1(2)*ev2(1)-ev1(1)*ev2(2))
      coef1 = -(u0(1)*ev2(2) - u0(2)*ev2(1))
     .      /(ev1(2)*ev2(1)-ev1(1)*ev2(2))
c
      errm = 0.d0
      err2 = 0.d0

c     write(1,*) 'time ', t
      do k = 1, nz
         do j =1, ny
            do l = 1, nvar
               do i = 1, nx
                  index = i+(l-1)*nx+(j-1)*meqnx+(k-1)*meqn*ny
                  p(index) = (coef1*ev1(l)*dexp(mu1*t)
     .                     +  coef2*ev2(l)*dexp(mu2*t))*p0(index)
c                  p(index) = u0(l)*dexp(-lambd*t)*p0(index) 
c                  write(6,*) i, j, k, l
c                  write(1,*) p(index), v(index) 
                  errm = dmax1(errm,dabs(p(index)-v(index)))
                  err2 = err2 + (p(index)-v(index))**2
               enddo
            enddo
         enddo
      enddo

      err2 = dsqrt(err2)/neqn

c     write(40,*) t
c     write(40,100) (v(k)-p(k), k=1,neqn)

      write(41,*) t, errm, err2

 100  format(1x,5d10.3)

      return
      end
