# /u/sy/beebe/src/benchmarks/othmer/histogram.awk, Sat Mar 22 16:40:28 1997
# Edit by Nelson H. F. Beebe <beebe@plot79.math.utah.edu>
# ========================================================================
# From the SUMMARY.3 file, make a histogram of relative performance of
# selected machines, to provide a compact visual summary.
#
# Usage:
#	gawk -f histogram.awk [-v MACHINE='regexp1|regexp2|...'] SUMMARY.3 >outfile
#
# [22-Mar-1997]
# ========================================================================

BEGIN	{
		FS = "\t"
		MAX_HISTOGRAM = 24
		## print "DEBUG: MACHINE=[" MACHINE "]"
	}

NF == 5 {
		if (MACHINE == "") # print all results
			print_histogram()
		else if (MACHINE && match($2,MACHINE)) # print selected results
			print_histogram()
	}

END	{
		if (Last_Benchmark != "")
		    print_hline()
	}

function print_histogram( bar,k,n)
{
    if ($1 ~ /Benchmark/)
    {
	if (Last_Benchmark != "")
	{
	    print_hline()
	    print ""
	}
	print_hline()
	printf("%-15s\t%-23s\t%7s\t%7s\t%s\n", $1, substr($2,1,23), "Ratio1", "Ratio2", "Histogram")
	print_hline()
    }
    else
    {
	if ($1 != Last_Benchmark) # new benchmark
	{
	    print ""
	    Max_Performance = $5
	    ## print "DEBUG: Max_Performance = ", Max_Performance
	    if (Max_Performance <= 0.0)
		Max_Performance = 1.0
	}
	n = int(MAX_HISTOGRAM*($5/Max_Performance))
	if (n < 0)
	{
	    n = 0
	    bar = ""
	}
	else if (n > MAX_HISTOGRAM)
	{
	    bar = ""
	    if (n > 5*MAX_HISTOGRAM)
		n = 5*MAX_HISTOGRAM
	    for (k = 1; k <= n; ++k)
		bar = bar "!"
	}
	else
	    bar = substr("################################",1,n)
	printf("%-15s\t%-23s\t%7.4f\t%7.4f\t%s\n", $1, substr($2,1,23), $5, $5/Max_Performance, bar)
    }
    Last_Benchmark = $1
}

function print_hline()
{
    print "================================================================================"
}
