# /u/sy/beebe/src/benchmarks/othmer/results.awk, Fri Apr  1 08:37:09 1994
# Edit by Nelson H. F. Beebe <beebe@plot79.math.utah.edu>
# ========================================================================
# Extract a table of timing results from the RESULTS files
# Usage:
#	nawk -f results.awk RESULTS
# [19-Dec-1997]
# ========================================================================

BEGIN \
{
    USER_CUTOFF = 10		# results with user time less than USER_CUTOFF are ignored

    machine["sn5652"]			= "Cray EL/94 (33 MHz, xx MB RAM)"
    machine["adam.math.utah.edu"]	= "HP 9000/735 (99 MHz, 32 MB RAM)"
    machine["alab01.math.utah.edu"]	= "DEC Alpha 3000/300LX (125 MHz, 32 MB RAM)"
    machine["alab05.math.utah.edu"]	= "DEC Alpha 3000/300LX (125 MHz, 32 MB RAM)"
    machine["alab06.math.utah.edu"]	= "DEC Alpha 3000/300LX (125 MHz, 64 MB RAM)"
    machine["alab07.math.utah.edu"]	= "DEC Alpha 3000/300LX (125 MHz, 64 MB RAM)"
    machine["alfred.math.utah.edu"]     = "DECstation 5000/200 (40 MHz, 24 MB RAM)"
    machine["asdec.math.utah.edu"]	= "DECstation 5000/200 (40 MHz, 24 MB RAM)"
    machine["athena.math.utah.edu"]	= "Sun SPARCstation 10/41 (40 MHz, 64 MB RAM)"
    machine["atrium.math.utah.edu"]	= "SGI Indigo-2 R4400 (150 MHz, 64 MB RAM)"
    machine["aztec.biology.utah.edu"]	= "SGI Indigo R3000 (33 MHz, 32 MB RAM)"
    machine["aztec.math.utah.edu"]	= "SGI Indigo R3000 (33 MHz, 32 MB RAM)"
    machine["becks.med.utah.edu"]	= "DEC Alpha 3000/400 (133 MHz, 96 MB RAM)"
    machine["becks"]			= "DEC Alpha 3000/400 (133 MHz, 96 MB RAM)"
    machine["cain.math.utah.edu"]	= "HP 9000/735 (99 MHz, 192 MB RAM)"
    machine["ces2.cs.utah.edu"]		= "IBM RS/6000-580 (256 MB RAM)"
    machine["ceslab01.math.utah.edu"]	= "SGI Indigo-2 R4400-150 (150 MHz, 64 MB RAM)"
    machine["ceslab02.math.utah.edu"]	= "SGI Indigo-2 R4400-150 (150 MHz, 64 MB RAM)"
    machine["ceslab03.math.utah.edu"]	= "SGI Indigo-2 R4400-150 (150 MHz, 64 MB RAM)"
    machine["ceslab04.math.utah.edu"]	= "SGI Indigo-2 R4400-150 (150 MHz, 64 MB RAM)"
    machine["ceslab05.math.utah.edu"]	= "SGI Indigo-2 R4400-150 (150 MHz, 64 MB RAM)"
    machine["cherokee.usi.utah.edu"]	= "IBM RS/6000-560 (128 MB RAM)"
    machine["cpt28.physics.utah.edu"]	= "IBM RS/6000-43P (133 MHz POWER PC, 64MB, 2GB)"
    machine["dakota.math.utah.edu"]	= "SGI Indigo-2 R4400 (200 MHz, 128 MB RAM)"
    machine["demo6.cs.utah.edu"]	= "IBM RS/6000-250 (66 MHz POWER PC, ??MB, 1GB)"
    machine["demo6-alpha.cs.utah.edu"]	= "DEC Alpha 3000-300LX (125 MHz, 32 MB RAM)"
    machine["demo7"]			= "HP 9000/712-80i (80 MHz, 32 MB RAM)"
    machine["demo7.cs.utah.edu"]	= "HP 9000/712-80i (80 MHz, 32 MB RAM)"
    machine["eilat.math.utah.edu"]	= "SGI Origin/200 R10000 (4 CPUs, 180 MHz, 384 MB RAM)"
    machine["eros.math.utah.edu"]	= "SGI Indigo R3000 (33 MHz, 32 MB RAM)"
    machine["eve.math.utah.edu"]	= "HP 9000/735 (99 MHz, 96 MB RAM)"
    machine["everst"]                   = "DEC 8400 5/300 (300 MHz, 4GB RAM)"
    machine["galil.math.utah.edu"]	= "HP 9000/735 (99 MHz, 144 MB RAM)"
    machine["geronimo.math.utah.edu"]	= "SGI Indigo R4000-100 (100 MHz, 80 MB RAM)"
    machine["goanna.math.utah.edu"]	= "SGI Indigo-2 R4400-200 (200 MHz, 96 MB RAM)"
    machine["hal.chpc.utah.edu"]	= "HALstation 385 (161 MHz, ?? MB RAM)"
    machine["honeycomb.math.utah.edu"]	= "SGI Indigo-2 R4000-100 (100 MHz, 64 MB RAM)"
    machine["hotbox.math.utah.edu"]	= "DEC Alpha 2100/5-250 (250 MHz, 3 CPUs, 2GB RAM)"
    machine["hpusluc"]			= "HP 9000/K400 (100 MHz, 3 CPUs, 896 MB RAM)" 
    machine["hpj200"]			= "HP 9000/J200 (100 MHz, 256 MB RAM)" 
    machine["inca.usi.utah.edu"]	= "SGI PC XL R8000 (75 MHz, 8 CPUs, 2 GB RAM)"
    machine["jadran.math.utah.edu"]	= "Sun SPARCstation 5/110 (110MHz, 32MB RAM)"
    machine["jeeves.math.utah.edu"]	= "DECstation 5000/200 (40 MHz, 24 MB RAM)"
    machine["load1.math.utah.edu"]	= "SGI Indigo-2 R8000 (75 MHz, 128 MB RAM)"
    machine["negev.math.utah.edu"]	= "SGI Indigo-2 R4400-150 (150 MHz, 64 MB RAM)"
    machine["golan.math.utah.edu"]	= "SGI O2 R10000-SC-150 (150MHz, 128 MB RAM, 1 MB cache)"
    machine["octane.math.utah.edu"]	= "SGI Octane R10000-195 (two 195MHz, 256 MB RAM, 1 MB cache/CPU)"
    machine["osiris.usi.utah.edu"]	= "IBM RS/6000-550 (42 MHz, ?? MB RAM)"
    machine["pender.math.utah.edu"]	= "SGI Indigo-2 R4400 (150 MHz, 64 MB RAM)"
    machine["piute.math.utah.edu"]	= "HP 9000/715-64 (64 MHz PA-RISC 7100LC, 32 MB RAM)"
    machine["plot79.math.utah.edu"]	= "Sun SPARCstation 10/41 (40 MHz, 32 MB RAM)"
    machine["quad.math.utah.edu"]	= "SGI Origin 200 (four 180 MHz, 256MB RAM)"
    machine["ultra170.math.utah.edu"]	= "Sun UltraSPARC 170 (167 MHz, 64 MB RAM)"

    # [25-Feb-1997] Changed strings from 200 to 175 for poincare.math.utah.edu
    # A bug in the SGI hinv program gave the incorrect 200MHz value,
    # but after SGI patches were applied, the answer is now correct:
    #	1 175 MHZ IP22 Processor
    #	Secondary unified instruction/data cache size: 1 Mbyte
    machine["poincare.math.utah.edu"]	= "SGI Indy R4400-175-SC (175 MHz, 32 MB RAM)"

    machine["redrvr"]			= "DEC Alpha 2100 (4 CPUs)"
    machine["rumplemeyer.math.utah.edu"] = "SGI Indy R4600-100-SC (100 MHz, 64 MB RAM)"
    machine["saetta.math.utah.edu"]	= "DEC Alpha 2100-5/250 (3 CPUs, 250 MHz, 2GB RAM)"
    machine["saturna.math.utah.edu"]	= "SGI Indigo R4000-100 (100 MHz, 64 MB RAM)"
    machine["sci2.cs.utah.edu"]		= "IBM RS/6000-580 (256 MB RAM)"
    machine["shasta"]			= "DEC Alpha 8400 5/300 (4 CPUs, 512 MB RAM, 4 RZ82)"
    machine["silverfork.math.utah.edu"]	= "Sun SPARCstation 2 (40MHz, 98MB RAM)"
    machine["sinai.math.utah.edu"]	= "HP 9000/735 (99 MHz, 80 MB RAM)"
    machine["slab02.math.utah.edu"]	= "Sun SPARCstation 10/30 (30MHz, 64MB RAM)"
    machine["solitude.math.utah.edu"]	= "Sun SPARCstation 10/51 (50 MHz, 64 MB RAM)"
    machine["sp2n1.usi.utah.edu"]	= "IBM RS/6000-SP2 (67 MHz, 128MB RAM)"
    machine["sp2n2.usi.utah.edu"]	= "IBM RS/6000-SP2 (67 MHz, 128MB RAM)"
    machine["sp2n3.usi.utah.edu"]	= "IBM RS/6000-SP2 (67 MHz, 128MB RAM)"
    machine["sp2n4.usi.utah.edu"]	= "IBM RS/6000-SP2 (67 MHz, 128MB RAM)"
    machine["sp2n5.usi.utah.edu"]	= "IBM RS/6000-SP2 (67 MHz, 128MB RAM)"
    machine["sp2n6.usi.utah.edu"]	= "IBM RS/6000-SP2 (67 MHz, 128MB RAM)"
    machine["sp2n7.usi.utah.edu"]	= "IBM RS/6000-SP2 (67 MHz, 128MB RAM)"
    machine["sp2n8.usi.utah.edu"]	= "IBM RS/6000-SP2 (67 MHz, 128MB RAM)"
    machine["sunblock.math.utah.edu"]	= "Sun UltraSPARC 2170 (2 CPUs, 167 MHz, 1024 MB RAM)"
    machine["sundown.math.utah.edu"]	= "Sun SPARCstation 20/512 (2 CPUs, 50 MHz, 64 MB RAM)"
    machine["sunray.math.utah.edu"]	= "Sun UltraSPARC 2200 (2 CPUs, 200 MHz, 1024 MB RAM)"
    machine["sunscreen.math.utah.edu"]	= "Sun UltraSPARC 2170 (2 CPUs, 167 MHz, 1024 MB RAM)"
    machine["sunshine.math.utah.edu"]	= "Sun SPARCstation 20/512 (2 CPUs, 50 MHz, 64 MB RAM)"
    machine["sunshine.usi.utah.edu"]	= "Sun UltraSPARC 2200 (2 CPUs, 200 MHz, 256 MB RAM)"
    machine["suntan.math.utah.edu"]	= "Sun UltraSPARC 2170 (2 CPUs, 167 MHz, 1024 MB RAM)"
    machine["test.math.utah.edu"]	= "DEC AlphaSt. 500/400 (400 MHz, 256MB RAM)"
    machine["tocsy.chem.utah.edu"]	= "IBM RS/6000-390 (67 MHz POWER2, 128 MB RAM, 64KB D-cache,32KB I-cache)"
    machine["todd.math.utah.edu"]	= "SGI Chall. L R4000-150 (150 MHz, 64 MB RAM)"
    machine["wave.math.utah.edu"]	= "SGI O2 R5000-PC-180 (180 MHz, 64 MB RAM)"
    machine["xian.math.utah.edu"]	= "HP 9000/715-64 (64 MHz PA-RISC 7100LC, 32 MB RAM)"
    machine["yiluo.gg.utah.edu"]	= "DEC Alpha 600/5-266 (266 MHz, 128 MB RAM)"
    machine["zuni.math.utah.edu"]	= "SGI Origin/200 R10000 (4 CPUs, 180 MHz, 384 MB RAM)"
}

/^Command:/ 			{ benchmark = trim(substr($0,9)) }

/^System:/  			{ uname = trim(substr($0,8)) }

/^Hostname:/			{ hostname = trim(substr($0,10)) }

/^Date:/			{ date = trim(substr($0,6)) }

/^Directory:/			{ directory = trim(substr($0,11)) }

/^Compilation options:/		{ options = trim(substr($0,21)) }

/^[0-9.]+user *[0-9.]+system/	{ hp_time() }
#/^[0-9.]+user/			{ hp_time() }

/Real *[0-9.]+$/		{ ibm_time() }

/User *[0-9.]+$/		{ ibm_time() }

/System *[0-9.]+$/		{ ibm_time() }

/real *[0-9.:]+$/		{ solaris_time() }

/user *[0-9.:]+$/		{ solaris_time() }

/sys *[0-9.:]+$/		{ solaris_time() }

/elapsed *[0-9.:]+ +[0-9]+$/	{ cray_time() }

/user *[0-9.:]+ +[0-9]+$/	{ cray_time() }

/sys *[0-9.:]+ +[0-9]+$/	{ cray_time() }

END   {}

function cray_time()
{
    #            seconds          clocks
    # elapsed  493.20988     16440329199
    # user     464.61424     15487141150
    # sys        2.61142        87047348


    # print "DEBUG: 0 = [" $0 "], 1 = [" $1 "], 2 = [" $2 "]"
    if ($1 == "elapsed")
        cray_elapsed_time = hhmmss($2)
    else if ($1 == "user")
        cray_user_time = hhmmss($2)
    else if ($1 == "sys")
    {
        cray_system_time = hhmmss($2)
	print_results(cray_user_time, cray_system_time, \
		      cray_elapsed_time, \
		      100*(cray_user_time + cray_system_time) / \
		      ((cray_elapsed_time > 0) ? cray_elapsed_time : 1))
	cray_elapsed_time = 0
	cray_user_time = 0
	cray_system_time = 0
    }
    else
    {
	print "?File ", FILENAME, "line ", FNR, \
		": Unknown Cray time string: ", $0 >"/dev/tty"
    }
}

function hhmmss(t, n,hh,mm,ss,hms)	# convert hh:mm:ss to seconds
{
    n = split(t, hms, ":")
    # print "DEBUG hhmmss: n = " n " [" $1 "] [" $2 "] [" $3 "]" >"/dev/tty"
    if (n == 1)
    {
	hh = 0
	mm = 0
	ss = hms[1]
    }
    else if (n == 2)
    {
	hh = 0
	mm = hms[1]
	ss = hms[2]
    }
    else if (n == 3)
    {
	hh = hms[1]
	mm = hms[2]
	ss = hms[3]
    }
    else 
    {
	print "?n = " n >"/dev/tty"
	print "?File ", FILENAME, "line ", FNR, \
		": Unknown hh:mm:ss time string: ", t >"/dev/tty"
	hh = 0
	mm = 0
	ss = 0
    }
    # print "DEBUG: hhmmss ->",(3600 * hh + 60 * mm + ss)
    return (3600 * hh + 60 * mm + ss)
}

function HHMMSS(seconds)
{
    return (sprintf("%3d:%02d:%05.2f",
		    int(seconds/3600),
		    int((seconds/60) % 60), \
		    seconds % 60))
}

function hp_time()
{
    # 24.73user 0.33system 0:50.67elapsed 49%CPU (0avgtext+0avgdata 0maxresident)k    

#    print "DEBUG: " $0 >"/dev/tty"
    gsub(/user/," user",$0)
    gsub(/system/," system",$0)
    gsub(/elapsed/," elapsed",$0)
    gsub(/CPU/," CPU",$0) 
#    print "DEBUG: hp_time [" $1 "] [" $2 "] [" $3 "] [" $4 "] [" $5 "] [" $6 "] [" $7 "]" >"/dev/tty"
    print_results(hhmmss($1), hhmmss($3), hhmmss($5), $7)
}

function ibm_time()
{
    # Real   1374.1
    # User   1369.8
    # System 1.5

#   print "DEBUG: 0 = [" $0 "], 1 = [" $1 "], 2 = [" $2 "]"
    if ($1 == "Real")
        ibm_elapsed_time = hhmmss($2)
    else if ($1 == "User")
        ibm_user_time = hhmmss($2)
    else if ($1 == "System")
    {
        ibm_system_time = hhmmss($2)
	print_results(ibm_user_time, ibm_system_time, ibm_elapsed_time, \
		      100*(ibm_user_time + ibm_system_time) / \
		      ((ibm_elapsed_time > 0) ? ibm_elapsed_time : 1))
	ibm_elapsed_time = 0
	ibm_user_time = 0
	ibm_system_time = 0
    }
    else
    {
	print "?File ", FILENAME, "line ", FNR, \
		": Unknown IBM time string: ", $0 >"/dev/tty"
    }
}

function print_results(user_time,system_time,elapsed_time,cpu_percentage)
{
    if (user_time < USER_CUTOFF) # to eliminate early failures (core dumps etc)
	return
    # print "DEBUG: print_results called"
    SORT_PIPE = "sort | nawk '{gsub(/\\\\n/,\"\\n\"); print}'"
    printf("\f\\n") | SORT_PIPE
    printf("Benchmark:               %s\\n", benchmark) | SORT_PIPE
    printf("Machine:                 %s\\n", machine[hostname]) | SORT_PIPE
    printf("Hostname:                %s\\n", hostname) | SORT_PIPE
    printf("Directory:               %s\\n", directory) | SORT_PIPE
    printf("Software:                %s\\n", uname) | SORT_PIPE
    printf("Compilation options:     %s\\n", options) | SORT_PIPE
    printf("Date:                    %s\\n", date) | SORT_PIPE
    printf("User time:               %10.2f %s\\n",
	   user_time, HHMMSS(user_time)) | SORT_PIPE
    printf("System time:             %10.2f %s\\n",
	   system_time, HHMMSS(system_time)) | SORT_PIPE
    printf("User + System time:      %10.2f %s\\n",
	   user_time + system_time,
	   HHMMSS(user_time + system_time)) | SORT_PIPE
    printf("Elapsed time:            %10.2f %s\\n",
	   elapsed_time, HHMMSS(elapsed_time)) | SORT_PIPE
    printf("CPU percentage:          %s\\n", cpu_percentage) | SORT_PIPE
    print "" | SORT_PIPE
}

function solaris_time()
{
    # real     7:51.2
    # user     6:38.7
    # sys         1.0


    # print "DEBUG: 0 = [" $0 "], 1 = [" $1 "], 2 = [" $2 "]"
    if ($1 == "real")
        solaris_elapsed_time = hhmmss($2)
    else if ($1 == "user")
        solaris_user_time = hhmmss($2)
    else if ($1 == "sys")
    {
        solaris_system_time = hhmmss($2)
	print_results(solaris_user_time, solaris_system_time, \
		      solaris_elapsed_time, \
		      100*(solaris_user_time + solaris_system_time) / \
		      ((solaris_elapsed_time > 0) ? solaris_elapsed_time : 1))
	solaris_elapsed_time = 0
	solaris_user_time = 0
	solaris_system_time = 0
    }
    else
    {
	print "?File ", FILENAME, "line ", FNR, \
		": Unknown Sun Solaris time string: ", $0 >"/dev/tty"
    }
}

function trim(s, t)
{
    t = s
    gsub(/^[ \t]*/,"",t)	# trim leading space
    gsub(/[ \t]*$/,"",t)	# trim trailing space
    return (t)
}
